typedef struct tagChaindir{
	LPTSTR dir;
	BOOL recurse;	// Only Search!
	struct tagChaindir* next;
} Chaindir;

enum{
	FOP_RENAME,
	FOP_OVERWRITE,
	FOP_THROUGH
};

enum{
	WALL_CENTER,
	WALL_TILE,
	WALL_STRETCH
};

struct tagOption{
	// Preview
	BOOL UsePreviewPane;
	BOOL KeepAspectRatio;
	int PreviewStretchMode;
	// PreviewWindow
	BOOL KeepPreviewWindowPos;

	// FileOperation
	BOOL UncheckWhenFOPSuccessful;
	// FileOperation2
	int HowtoWhenAlreadyExist;

	// Listing
	BOOL ListupAllFiles;
	BOOL FastScan;

	// [Enter]
	BOOL OldEnterOperation;

	// ToolbarDefault
	BOOL TBFindAlwaysAsk;
	BOOL TBCopyAlwaysAsk;
	BOOL TBMoveAlwaysAsk;
	BOOL TBTrashIsDelete;
	int TBWallDefaultStyle;

	//
	BOOL reShowSetting;

	// Recent
	UINT recentScandirItems;
	UINT recentCopydirItems;
	UINT recentMovedirItems;

	Chaindir* recentScandir;
	Chaindir* recentCopydir;
	Chaindir* recentMovedir;
};

extern struct tagOption Option;
extern SUSIEPLUGIN* SPIroot;
extern TCHAR gSpiDir[MAX_PATH];
