#include <windows.h>
#include "resource.h"
#include "common.h"
#include "rstring.h"
#include "spi.h"
#include "main.h"

// free`͒PɃXg؂肽ƂɎg܂B
void freeSusiePluginChain(SUSIEPLUGIN* spi)
{
	// freeeeee!!
	while(spi)
	{
		SUSIEPLUGIN* s = spi->next;
		//FreeLibrary(spi->hModule);	// Not FreeLibrary
		hfree(spi);
		spi = s;
	}

	return;
}

// destroy`͍ŏIʂł̂ݎg܂B
void destroySusiePluginChain(SUSIEPLUGIN* spi)
{
	// freeeeee!!
	while(spi)
	{
		SUSIEPLUGIN* s = spi->next;
		FreeLibrary(spi->hModule);
		hfree(spi);
		spi = s;
	}

	return;
}

BOOL scanSusiePlugins(void)
{
	TCHAR cdir[MAX_PATH];

	GetCurrentDirectory(sizeof(cdir), cdir);
	if(!SetCurrentDirectory(gSpiDir))
	{
		MessageBox(NULL, String(IDS_SPISCANFAIL_FAILEDCHANGECWD), String(IDS_ERROR), MB_ICONERROR | MB_OK);
		return FALSE;
	}

	{
		WIN32_FIND_DATA wfd;
		HANDLE hFind;

		if((hFind = FindFirstFile(TEXT("*.spi"), &wfd)) != INVALID_HANDLE_VALUE)
		{
			do{
				// XL&ZbgSUSIEPLUGIN
				HMODULE hDll;

				if(hDll = LoadLibrary(wfd.cFileName))
				{
					// DLL[hAC𔲂Ă͂Ȃ! zSusiePluginłȂȂ! (˂
					SUSIEPLUGIN* spi;

					// m: TODO: s͋CɂȂ...?mjsk!?
					spi = halloc(sizeof(SUSIEPLUGIN));

					// Zbg
					spi->hModule = hDll;
					lstrcpy(spi->ModuleName, wfd.cFileName);
					spi->use = TRUE;
					spi->num = 0;
					spi->next = NULL;
					// ֐
					// ₤lpProcNameTEXT()Ƃ낾BLPCSTRłLPC'T'STRł͂ȂB
					// TODO: NULL̏ꍇǂ(֐)
					(FARPROC)spi->GetPluginInfo = GetProcAddress(hDll, "GetPluginInfo");
					(FARPROC)spi->IsSupported = GetProcAddress(hDll, "IsSupported");
					(FARPROC)spi->GetPictureInfo = GetProcAddress(hDll, "GetPictureInfo");
					(FARPROC)spi->GetPicture = GetProcAddress(hDll, "GetPicture");
					(FARPROC)spi->ConfigurationDlg = GetProcAddress(hDll, "ConfigurationDlg");

					// ܂IN? (TODO: IMΉ)
					{
						CHAR ts[5];

						spi->GetPluginInfo(0, ts, sizeof(ts));
						if(BE4(ts) != BE4("00IN"))
						{
							// Oh you ain't 00IN! fuck you!
							destroySusiePluginChain(spi);
							continue;
						}
					}

					// (00INƊmF)ǉ
					if(SPIroot == NULL)
						SPIroot = spi;
					else
					{
						SUSIEPLUGIN* s = SPIroot;

						while(s->next)
							s = s->next;

						s->next = spi;
					}
				}
			}while(FindNextFile(hFind, &wfd));

			FindClose(hFind);
		}
	}

	SetCurrentDirectory(cdir);

	if(!SPIroot)
	{
		//MessageBox(NULL, String(IDS_NOSPI), String(IDS_WARNING), MB_ICONWARNING | MB_OK);
		return FALSE;
	}

	return TRUE;
}

int PASCAL NullGetPictureCallBack(int nNum, int nDenom, long lData)
{
	return 0;	// Always ACK
}

// spiGetPicture returns DIB.
HBITMAP spiGetPicture(LPCTSTR fname)
{
	SUSIEPLUGIN* spi;

	HANDLE hf;

	HBITMAP rethbm = NULL;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE)
	{
		BYTE tmpbuf[2048] = {0};	// TODO: ȂƂbuffer overflowtO & 0tBSPI̎dl
		DWORD len;

		ReadFile(hf, tmpbuf, 2048, &len, NULL);

		CloseHandle(hf);

		for(spi = SPIroot; spi; spi = spi->next)
		{
			HLOCAL hBI, hBM;

			// TODO: UnicodeɂƎʁBvUnicodeToMultibyte?
			if(spi->IsSupported((LPSTR)fname, (DWORD)tmpbuf) && !spi->GetPicture((LPSTR)fname, 0, 0, &hBI, &hBM, NullGetPictureCallBack, 0))
			{
				BITMAPINFO* bi;
				BYTE* bm;

				bi = LocalLock(hBI);
				bm = LocalLock(hBM);

				{
					HWND hDesk;
					HDC hdc;
					HBITMAP hbm;

					// Win98΍
					hdc = GetDC(hDesk = GetDesktopWindow());

					//hbm = CreateBitmap(bi->bmiHeader.biWidth, bi->bmiHeader.biHeight, 1, bi->bmiHeader.biBitCount, bm);
					hbm = CreateDIBSection(NULL, bi, DIB_RGB_COLORS, NULL, NULL, 0);
					// hdc:dummy
					if(!SetDIBits(hdc, hbm, 0, bi->bmiHeader.biHeight, bm, bi, DIB_RGB_COLORS))
						MessageBeep(MB_ICONERROR);

					ReleaseDC(hDesk, hdc);

					rethbm = hbm;
				}

				LocalUnlock(hBI);
				LocalUnlock(hBM);

				LocalFree(hBI);
				LocalFree(hBM);

				break;
			}
		}
	}

	return rethbm;
}
